<CsoundSynthesizer>
<CsOptions>
-odac
</CsOptions>
<CsInstruments>

sr=44100
ksmps=100
nchnls=1
0dbfs=1


opcode warp,0,iiiiiii
	

inumbins, iampin, iampout, iwarp, ifreqout, ifreqin, icount  xin

; make sure we start with an empty table
iclear 	ftgen 0, 0, inumbins, -2, 0


	tablecopy iampout, iclear
	tablecopy ifreqout, ifreqin
	tablecopy icount, iclear

kindex = 0

loop:

kwarp		tab   kindex, iwarp
kwarp = round(kwarp)
kAmp		tab   kindex, iampin

kFreq		tab   kindex, ifreqin

kAmpTest	tab   kwarp, iampout
ktest		tab   kwarp, icount
		tablew  1/(ktest+1), kwarp, icount 	



kAmpAdd=kAmpTest

if (ktest = 0) then
	tablew  kFreq, kwarp, ifreqout
	tablew  kAmp, kwarp, iampout
elseif (kAmp>kAmpTest) then
	tablew  kFreq, kwarp, ifreqout
	tablew  kAmp+kAmpAdd, kwarp, iampout
else
	tablew  kAmp+kAmpAdd, kwarp, iampout
endif




kindex = kindex + 1


if (kindex < inumbins) kgoto loop
	
	vmultv  iampout, icount, inumbins 

endop
	

giwarp	ftgen 1000,0,8193,-7,0,8193, 8193 


instr 1

ain1	in

iCount1  ftgen 0,0,8193,-2,0
iampin   ftgen 0,0,8193,-2,0
iampout  ftgen 0,0,8193,-2,0
ifreqin  ftgen 0,0,8193,-2,0
ifreqout ftgen 0,0,8193,-2,0


kfftsize	invalue "fftsize"
kol 		invalue "ol"
kwindmult 	invalue "windmult"
kwindtype 	invalue "windtype"

ktrig           changed     kfftsize,kol, kwindmult, kwindtype 
if ktrig = 1 then
                reinit      pass
endif

pass:

ifftsize =  i(kfftsize)
iol = i(kol)
iNumBins = ifftsize/2 + 1
ihop = ifftsize/iol
iwindow = ifftsize*i(kwindmult)
iwindtype = i(kwindtype)

if (ihop >= ifftsize) then
ihop          =           ihop / 2
endif

if (ihop < 128) then
ihop          =           128
endif

kdry = 0 ;	chnget "dry"
;kdry	port kdry, 0.01
kwet = 1 ;	chnget "wet"
;kwet	port kwet, 0.01
ain1	in
;ain1 diskin2 "/Applications/Max5/examples/sounds/cherokee.aif", 1, 0, 1

klock	chnget	"lock" 
kfreez	chnget	"freez"	
			denorm	ain1 

fsig1 pvsanal ain1, ifftsize, ihop, iwindow, iwindtype

fsigfreez	pvsfreeze	fsig1, kfreez, kfreez

;idel=iwindow/sr
;aout3	delay ain1,idel 





; export fsig to tables
kflag pvsftw fsigfreez, iampin, ifreqin

if (kflag == 1) then ; only proc when frame is ready
;warp 
	warp iNumBins, iampin, iampout, giwarp, ifreqout, ifreqin, iCount1

; read modified data back to fsrc
	pvsftr fsigfreez, iampout, ifreqout

endif


aout1 pvsynth fsigfreez


out aout1

endin	


</CsInstruments>
<CsScore>

i1 0 3600
e

</CsScore>
</CsoundSynthesizer>
